<?php
/**
 * Callback controller, handles all callback requests
 *
 * @package blesta
 * @subpackage blesta.app.controllers
 * @copyright Copyright (c) 2010, Phillips Data, Inc.
 * @license http://www.blesta.com/license/ The Blesta License Agreement
 * @link http://www.blesta.com/ Blesta
 */
class Callback extends AppController {
	
	/**
	 * Setup
	 */
	public function preAction() {
		// Disable automatic CSRF check
		Configure::set("Blesta.verify_csrf_token", false);
		
		parent::preAction();
	}
	
	/**
	 * Handle backward compmatible gateway callback requests
	 */
	public function index() {
		
		// Backward compatible gateway callback requests (Blesta version 2.x)
		if (isset($this->get['gw']) || isset($this->post['gw'])) {

			#
			# TODO: Set mapping from 2.x RECURRING non-merchant gateway names to 3.x gateway names
			# old gateways may process 'uid' different than new gateways...
			# $client_id = $this->get['uid'];
			# $gateway_name = "...";
			#
			
			$this->gw($gateway_name);
		}
		
		// Nothing here, redirect back to landing page
		$this->redirect();
	}
	
	/**
	 * Handle gateway callbacks
	 */
	public function gw($gateway_name=null) {

		$this->components(array("GatewayPayments"));
		
		// Company ID is in the 1st parameter
		if (isset($this->get[0])) {
			$this->company_id = $this->get[0];
			Configure::set("Blesta.company_id", $this->company_id);
		}

		// Gateway name in the 2nd parameter
		if ($gateway_name === null && isset($this->get[1]))
			$gateway_name = $this->get[1];
		
		// Process the payment notification from the gateway
		$this->GatewayPayments->processNotification($gateway_name, $this->get, $this->post);
		
		return false;
	}
}
?>